<?
session_start ();

include_once ("../config.php");
include_once ("../smallfunc.php");
$lang = $GLOBALS['strings_kassa'];
$lang['curr'] = $GLOBALS['curr'];

function auth() {
	if (!isset($_SESSION['chaiserauth'])) $_SESSION['chaiserauth'] = false;
	if (!$_SESSION['chaiserauth']) return false;
	
	
	$kass=$GLOBALS['chaisers'];
			
	$sum = count($kass,1) /9 - 1;
	for($q=0; $q <= $sum - 1; $q++) 
	{ 
		$DBlogin = $kass['login'][$q];
		$DBpass = $kass['password'][$q];
		$Groups = $kass['groups'][$q];
		$FIO = $kass['fio'][$q];
		$GUID = $kass['guid'][$q];
		$availablefrom = $kass['availablefrom'][$q];
		$parent_master = $kass['parent_master'][$q];
		$parent_net_master = $kass['parent_net_master'][$q];
				
		if (($_SESSION['chaiserlogin'] == $DBlogin) && ($_SESSION['chaiserpassword'] == $DBpass)) {
					
			if ($DBlogin <> "") {

				$_SESSION['availablefrom'] = $availablefrom;
				$_SESSION['chaisergroups'] = explode("||",$Groups);
												
				if (CheckAuthIP()) {

					$_SESSION['chaisergroups'] = explode("||",$Groups);
					$_SESSION['chaiserfio'] = $FIO;
					$_SESSION['parent_master'] = $parent_master;
					$_SESSION['parent_net_master'] = $parent_master;
					$_SESSION['chaiserguid'] = $GUID;

				} else {
					$_SESSION['chaisergroups'] = '';
					$_SESSION['chaiserfio'] =  '';
					$_SESSION['chaiserguid'] = '';
					$_SESSION['parent_master'] = 0;
					$_SESSION['parent_net_master'] = 0;
					$_SESSION['chaiserauth'] = false;
				}
			}
		}
	}
	
	
	return true;
}
function get($request) {
	return isset($_GET['page']) && strlen($_GET['page']) > 0 && array_key_exists($_GET['page'], $request) ? $_GET['page'] : NULL;
}

class content
	{
		private $path;
		private $file;
		private $lang;

		function __construct($path, $lang){
			$this->lang = $lang;
			$this->path = './html/'.str_replace(array('..', ':', '\\', '<?'), '', $path);
		}
		private function get() {
			if(file_exists($this->path)) {
				$this->file = file_get_contents($this->path);
				return true;
			}
		}
		private function lng_parse() {
			$this->file = str_replace('<?', '', $this->file);
			$this->file = str_replace('%curr%', $this->lang['curr'], $this->file);
			$i = 0;
			$i = strpos($this->file, '%STRINGS_', $i);
			while(($i < strlen($this->file)) && ($i==true)) {				
				$j = strpos($this->file, '%', $i+9);
				if($j) {
					$v1 = trim(substr($this->file, $i+9, $j-$i-9));
					$v2 = substr($this->file, $i, $j-$i+1);
					$this->file = str_replace($v2, $this->lang[(int)$v1], $this->file);
				}			
				$i += 10;
				if($i < strlen($this->file)){
					$i = strpos($this->file, '%STRINGS_', $i);
				}
			}
		}
		function read() {
			if($this->get())
				$this->lng_parse();
			return $this->file;		
		}
	}


/* Разрешенные страницы */

$request = array(
	'tarif' => $lang[434],	// Форма тарифа
	'group' => $lang[564],	// Форма группы
	'new' => 'New form'
);

/* Переменные страницы */

$title = isset($GLOBALS['PortalName']) && strlen($GLOBALS['PortalName']) > 0 ? $GLOBALS['PortalName'] : 'MikroBILL';
$out = auth() ? array(
	'login' => $_SESSION['chaiserlogin'],
	'logo' => $title,
	'title' => $lang[602] . ' - ' . $title,
	'description' => $lang[429].' '.$title,
	'content' => '',
	'copyrite' => date("Y").' © '.$title.', '.$GLOBALS['kassa_ver']
) : array();

/* GET Запросы */

$get = auth() ? get($request) : false;

// Неразрешенный запрос

if($get === NULL) {
	$obj = new content('error.html', $lang);
	$out['content'] = $obj->read();
	$out['title'] .= ' - Error Request';
}

// Неавторизованный запрос

if($get === false)
	header('Location: index.php');

// Запрос страницы

if($get) {
	$obj = new content($get.'.html', $lang);
	$out['content'] = $obj->read();
	$out['title'] .= ' - '.$request[$get];
}

$out['content'] .= "
	<script>var lang = {609: '$lang[609]', 610: '$lang[610]', 611: '$lang[611]', 612: '$lang[612]', 613: '$lang[613]', 614: '$lang[614]', 615: '$lang[615]', 616: '$lang[616]'};</script>";

?>
<!doctype html>
<html>
 <head>
  <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
  <meta http-equiv="Content-Language" content="ru">
  <meta name="Author" content="MikroBILL">
  <meta name="Keywords" content="">
  <meta name="Description" content="<?= $out['description'] ?>">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <meta name="theme-color" content="#5f80b3">
  <title><?= $out['title'] ?></title>
  <link href="./template/css/style2.css?003" type="text/css" rel="stylesheet" />
  <script type="text/javascript" src="./template/js/script.js?004"></script>
 </head>
 <body>
 	<header>
		<div>
			<div class="left">
				<div class="logo"><?= $out['logo'] ?></div>
				<div class="small"><?= $out['login'] ?></div>
			</div>
			<p class="menu"><?=$lang[606]?></p>
			<nav class="right">
				<a href="./" class="home"><?=$lang[607]?></a>
				<a href="index.php?logout=1" class="logout"><?=$lang[608]?></a>
			</nav>
		</div>
	</header>
	<?= $out['content'] ?>
	<footer><?= $out['copyrite'] ?></footer>
 </body>
</html>