<?php

//if (!isset($_REQUEST['command'])) {echo "Hello my World!";exit();}
if (!isset($_REQUEST['method'])){
	echo 'Hello my world!';
	exit();
}

include_once "../../config.php";

error_reporting(E_ALL);
ini_set('display_errors', '1');

header('Content-Type: text/html; charset=utf8');
header('Content-Type: text/xml');

$isLogEnable = true;
writeToLog($_SERVER['REQUEST_URI'], 'Запрос');

if ($GLOBALS ["EnableGorod74"] != 'True'){exit();}


if ($GLOBALS ["UseGorod74_IPFilter"] == 'True') {
	$allowed_ips = $GLOBALS ['Gorod74_allowed_ips'];
	if (array_search($_SERVER["REMOTE_ADDR"], $allowed_ips) === false) {
		sendError(8, 'Запрос выполнен из неразрешенного адреса');
	}
}


try {
	$attr = explode(':',$GLOBALS['mysql_adr']);
    $connection = new PDO("mysql:host=".$attr[0].";port=".$attr[1].";dbname=" . $GLOBALS['mysql_db'], $GLOBALS['mysql_user'], $GLOBALS['mysql_pass'], [PDO::ATTR_DEFAULT_FETCH_MODE => PDO::FETCH_ASSOC]);
    $connection->exec("SET NAMES utf8");
} catch (Exception $e) {
    sendError(300, 'Невозможно установить соединение с БД');
}


if (!isset($_REQUEST['service'])){$_REQUEST['service']='';}

$GoodChars = array('a','b','c','d','e','f','g','h','i','j','k','l','m','n','o','p','q','r','s','t','u','v','w','x','y','z', 
				   'A','B','C','D','E','F','G','H','I','J','K','L','M','N','O','P','Q','R','S','T','U','V','W','X','Y','Z',
				   '0','1','2','3','4','5','6','7','8','9','-','_');
				   
$array = str_split($_REQUEST['account']);

foreach ($array as $char) {
	if (array_search($char,$GoodChars) === false) {
		sendError(4, 'Ошибка в данных');
	}
}

if (!isset($_REQUEST['login'])){$_REQUEST['login']='';}
if (!isset($_REQUEST['password'])){$_REQUEST['password']='';}
if (!isset($_REQUEST['service'])){$_REQUEST['service']='';}
if (!isset($_REQUEST['summ'])){$_REQUEST['summ']='0';}

//$_REQUEST['summ'] = (float)$_REQUEST['summ'] / 100;

if (($_REQUEST['login']<>$GLOBALS['Gorod74Login']) || ($_REQUEST['password']<>$GLOBALS['Gorod74Password']) || (($_REQUEST['service']<>$GLOBALS['Gorod74ServiceID']) and (strlen($_REQUEST['service'])>0))){
	sendError(8, 'Неверные данные магазина');
}


$command = $_REQUEST['method'];
switch ($command) {
    case 'check':
        check();
        break;
    case 'pay':
        pay();
        break;
    default:
        sendError(300, 'Неизвестная команда');
}

function check()
{

	if (!is_numeric($_REQUEST['summ'])){
		sendError(300, 'Ошибка в данных');
	}
	
    global $connection;
	$account=$_REQUEST['account'];
	$clientA = explode("_", $account);
	if (count($clientA)>1){
		$short_guid2=$clientA[1];
	} else {$short_guid2=0;}
	
    if ((float)$_REQUEST['summ'] < $GLOBALS['Gorod74MinPlat']) {
        sendError(241, 'Сумма слишком мала');
    }
    $stm = $connection->prepare("SELECT contract, FIO AS `fio`, `ballance`, `otherinfo` FROM `stat` WHERE (`shortguid2` = ? or `user_name` = ? or `contract` = ?) AND `isarchived` = 0;");
    $stm->execute([$short_guid2, $account, $account]);
    $user = $stm->fetch();
    if ($user) {
		$bal=explode(' ',$user['ballance']);
		$bal=$bal[0];
		$bal=str_replace(',','.',$bal);
		$fio=$user['fio'];
		
		$fio = str_replace('  ', ' ', $fio);
		$fioA = explode(' ',$fio);
		if (count($fioA)==3){
			$fio = $fioA[0] . ' ' . mb_substr($fioA[1],0,1,'utf-8') . '. ' . mb_substr($fioA[2],0,1,'utf-8') . '.';
		}
		
		$otherinfo=explode('||',$user['otherinfo']);
		$debt=str_replace(',','.',$otherinfo[74]);
		if ((float)$debt<>0){$debt=-$debt;}
		
		    echo "<?xml version=\"1.0\" encoding=\"utf-8\" ?> 
<Answer>
 <Message>$fio</Message>
 <Debt>$debt</Debt>
 <Code>0</Code> 
</Answer>";

    } else {
        sendError(5, 'Клиент не найден');
    }
}

function pay()
{
    global $connection;
	$account=$_REQUEST['account'];
	$account=strtoupper($account);
    $query = "SELECT id, `date` FROM operations_gorod74 WHERE operation_id = ?";
    $stm = $connection->prepare($query);
    $stm->execute([$_REQUEST['payid']]);
    $payment = $stm->fetch();
	
   
   if (!is_numeric($_REQUEST['summ'])){
		sendError(300, 'Ошибка в данных');
	}
	
	$order_id = $_REQUEST['account'];
	$clientA = explode("_", $order_id);
	if (count($clientA)>1){
		$short_guid2=$clientA[1];
	} else {$short_guid2=0;}
	
    $stm = $connection->prepare("SELECT `shortguid` FROM `stat` WHERE `shortguid2` = ? or `user_name` = ? or `contract` = ?;");
    $stm->execute([$short_guid2, $account, $account]);
    $user = $stm->fetch();
    if ($user == false) {	
		$stm = $connection->prepare("INSERT INTO `unknown_payments` (`moneytime`,`cash`,`pay_type`,`comment`) VALUES (?,?,56,?);");
		$stm->execute([time(), $_REQUEST['summ'], $short_guid2]);
        sendError(5, "Не найден идентификатор абонента");
    }
	
	$LastInsID = -1;
	if ($payment == false) {
		
		$D = date("Y/m/d H:i:s", time());
		$dateTime = date("Y-m-d H:i:s", time());
		$uid = uniqid("", true) . uniqid("", true);
		$stm = $connection->prepare("INSERT INTO addcash2 VALUES (?,?,0,'GOROD74',0, ?, ?,?);");
		$stm->execute([$user['shortguid'], $_REQUEST['summ'], $uid, '', $dateTime]);

		$stm = $connection->prepare("INSERT INTO actionslog VALUES (?,'ADD_MONEY',?,?,'','')");
		$stm->execute([$dateTime, $user['shortguid'], $_REQUEST['summ']]);

		$stm = $connection->prepare("INSERT INTO `refresh_db` VALUES (1);");
		$stm->execute();

		$query = "INSERT INTO operations_gorod74 (`contract`,`sum`,`operation_id`,`date`) VALUES (?,?,?,?)";
		$stm = $connection->prepare($query);
		$stm->execute([$user['shortguid'], $_REQUEST['summ'], $_REQUEST['payid'], $dateTime]);
		
		$LastInsID =  $connection->lastInsertId();
		
		echo "<?xml version=\"1.0\" encoding=\"utf-8\" ?> 
<Answer> 
 <Code>0</Code>
 <PlatID>$LastInsID</PlatID> 
 <Status>0</Status> 
 <Date>$D</Date> 
</Answer>";

	} else {
		$LastInsID = $payment['id'];
		$D = date("Y/m/d H:i:s", strtotime($payment['date']));
		
		sendError(5, "Платёж уже проведён");
	}
	
	
	


}


function sendError($code, $comment)
{
    echo "<?xml version=\"1.0\" encoding=\"utf-8\" ?> 
<Answer>
<Message>$comment</Message> 
 <Code>$code</Code> 
</Answer>";

    writeToLog($comment, 'Ответ');
    exit;
}

function writeToLog($message, $type)
{
    global $isLogEnable;
    if ($isLogEnable) {
        $string = '[' . date("Y:d:m H:i:s") . '] ' . $type . ': ' . str_replace(["\r\n", "\n", "\r"], '', $message) . PHP_EOL;
        file_put_contents('payin.txt', $string, FILE_APPEND | LOCK_EX);
    }
}
