<?php
include_once '../../config.php';
require_once './IPay.php';
require_once './Mikrobill.php';


if ((!isset($_REQUEST['amount']))&&(!isset($_REQUEST['xml']))){echo "Hello my World!";exit();}

/**
$allowed_ips = [
    '138.201.198.87',
    '77.120.119.159',
    '77.120.97.36',
    '127.0.0.1'
];

if (array_search($_SERVER['REMOTE_ADDR'], $allowed_ips) === false) {
    echo "Запрос выполнен с неразрешенного адреса";
    exit;
}
**/
	//ini_set('display_errors', 1);
	//ini_set('display_startup_errors', 1);
	//error_reporting(E_ALL);

if ($GLOBALS ["EnableiPay"] <> 1) {exit();}

$iPayIsTest = false;



try {
	$MySQL_Host = explode(':',$GLOBALS['mysql_adr']);
	$MySQL_Port = $MySQL_Host[1];
	$MySQL_Host = $MySQL_Host[0];
    $pdo = new PDO(sprintf("mysql:host=%s;port=%s;dbname=%s;charset=UTF8;", $MySQL_Host, $MySQL_Port, $GLOBALS['mysql_db']), $GLOBALS['mysql_user'], $GLOBALS['mysql_pass']);
    $api = new Mikrobill($pdo);
    switch ($_REQUEST['action']) {
        case 'create':
            if (!$_REQUEST['amount']) {
                throw new Exception('Empty field "amount"');
            }
            session_start();
			
			$params = GetPayIDformLogin($_SESSION['contract']);
			$iPay = new IPay($api, $params);
            $iPay->createPayment($_SESSION['contract'], $_REQUEST['amount'], filter_var($iPayIsTest, FILTER_VALIDATE_BOOLEAN));
            break;
        default:
            if (!$_REQUEST['xml']) {
                throw new Exception('Empty field "xml"');
            }
			
			if ($GLOBALS["UseiPay_IPFilter"] == 'True') {
				$allowed_ips = $GLOBALS['iPay_allowed_ips'];
				if (array_search($_SERVER["REMOTE_ADDR"], $allowed_ips) === false) {
					echo("Запрос выполнен с неразрешенного IP адреса!");
					exit();
				}
			}
			
			$fp = fopen("payin.txt", "a"); 
			fputs($fp, "\n\nDate = " . date("d.m.y H:i:s")."\n");
			fputs($fp,  print_r($_REQUEST, true));
			fclose($fp);
			
			$xml = new SimpleXMLElement($_REQUEST['xml']);
						
			$transaction = $xml->transactions->transaction;
            $userId = json_decode($transaction->info,false, 512, JSON_BIGINT_AS_STRING)->shortguid;
			
			$userId = mysql_real_escape_string($userId);
			$sql = "SELECT `user_name` FROM `stat` WHERE `shortguid` = '$userId';";

			$mysqlResult = mysql_query($sql,$GLOBALS["mysql"]);
			if (mysql_num_rows($mysqlResult)>0){
				$row = mysql_fetch_array($mysqlResult);
				$user_name=$row[0];
			}
			$params = GetPayIDformLogin($user_name);
			
			$iPay = new IPay($api, $params);
            $iPay->pay($xml);
    }
} catch (Exception $e) {
    echo $e->getMessage();
}


function GetPayIDformLogin($login){
	
	global $iPayIsTest;
	
	$iPayID=-1;

	$login = mysql_real_escape_string($login);
	$sql = "SELECT `otherinfo` FROM `stat` WHERE `user_name` = '$login' or `contract` = '$login';";

	$mysqlResult = mysql_query($sql,$GLOBALS["mysql"]);
	if (mysql_num_rows($mysqlResult)>0){
		$row = mysql_fetch_array($mysqlResult);
		$otherinfo = explode("||",$row[0]);
		$iPayID=$otherinfo[150];
	}

	$iPayMerchantID = '';
	$iPayLegalID = '';
	$iPayMerchantKey = '';
	$iPayGatewayKey = '';
	$iPayFirmName = '';
	$iPayIsTest = false;
			
	if ((int)$iPayID >-1){
		$sql = "SELECT `params` FROM `payment_params` WHERE `id` = '$iPayID';";
		$mysqlResult = mysql_query($sql,$GLOBALS["mysql"]);
		if (mysql_num_rows($mysqlResult)>0){
			$row = mysql_fetch_array($mysqlResult);
			$Params = GetParams($row[0]);

			$iPayMerchantID  = $Params['iPayMerchantID'];
			$iPayLegalID = $Params['iPayLegalID'];
			$iPayMerchantKey = $Params['iPayMerchantKey'];
			$iPayGatewayKey = $Params['iPayGatewayKey'];
			$iPayFirmName = $Params['iPayFirmName'];
			$iPayIsTest = $Params['iPayIsTest'];
		}
	} else  {
		$sql = "SELECT `params`, `id` FROM `payment_params` WHERE `type` = 47;";
		$mysqlResult = mysql_query($sql,$GLOBALS["mysql"]);
		if (mysql_num_rows($mysqlResult)>0){
			$row = mysql_fetch_array($mysqlResult);
			$Params = GetParams($row[0]);
			$iPayID=$row[1];

			$iPayMerchantID  = $Params['iPayMerchantID'];
			$iPayLegalID = $Params['iPayLegalID'];
			$iPayMerchantKey = $Params['iPayMerchantKey'];
			$iPayGatewayKey = $Params['iPayGatewayKey'];
			$iPayFirmName = $Params['iPayFirmName'];
			$iPayIsTest = $Params['iPayIsTest'];
		}
	}
	$GLOBALS ["iPayID"]=$iPayID;

	$params = [
		'mch_id' => $iPayMerchantID,                                                                  //идентификатор мерчанта
		'mch_key' => $iPayMerchantKey,                         //ключ мерчанта для подписи
		'gtw_key' => $iPayGatewayKey,                         //ключ платёжного шлюза для подписи
		'smch_id' => $iPayLegalID ,                                                                 //юр. лицо куда зайдут деньги если их несколько
		'description' => 'Обслуговування локальної мережі згідно договору #USER#',         //коментарий платежа (#USER# будет заменено на логин абонента)
		'currency' => 'UAH',                                                             //валюта
		'trademark' => $iPayFirmName,                                                        //Название оператора
		'url_good' => $GLOBALS["PaySite"],                                               //url куда перенаправит абонента в случае успешной оплаты
		'url_bad' => $GLOBALS["PaySite"]                                                 //url куда перенаправит абонента в случае неуспешной оплаты
	];
	
	return $params;
	
}


function GetParams($ParamsString){
	$Ret=array();
	$ParamsA = explode("||",$ParamsString);
	for ($i = 0; $i < count($ParamsA)-1; $i+=2) {
		$Ret[$ParamsA[$i]]=$ParamsA[$i+1];
	}
	return $Ret;
}
