<?php

if (!isset($_REQUEST['QueryType'])){
	echo "Hello my World!";
	exit();
}
 
include_once "../../config.php";
include_once "../../smallfunc.php";
header('Content-Type: text/xml');

if ($GLOBALS ["UseRNKB"] <> "True") {exit();}

if ($GLOBALS ["UseRNKB_IPFilter"] == 'True') {
	$allowed_ips = $GLOBALS ['RNKB_allowed_ips'];
	if (array_search($_SERVER["REMOTE_ADDR"], $allowed_ips) === false) {
		error(22, "Запрос выполнен с неразрешенного IP адреса!", -1);
	}
}

writeToLog($_SERVER['REQUEST_URI'], 'Запрос');

try {
	$attr = explode(':',$GLOBALS['mysql_adr']);
    $connection = new PDO("mysql:host=".$attr[0].";port=".$attr[1].";dbname=" . $GLOBALS['mysql_db'], $GLOBALS['mysql_user'], $GLOBALS['mysql_pass']);
    $connection->exec("SET NAMES utf8");
} catch (Exception $e) {
    error(23, 'Невозможно установить соединение с БД', -1);
}

if (isset($_REQUEST['QueryType'])) {
    $action = $_REQUEST['QueryType'];
    
    switch ($action) {
        case 'check':
			$account = $_REQUEST['Account'];
            check($account, $connection);
            exit;
            break;
        case 'pay':
            $amount = $_REQUEST['Summa'];
			$account = $_REQUEST['Account'];
            pay($_REQUEST['Payment_id'], $account, $amount, $connection, $_REQUEST['Exec_date']);
            exit;
            break;
		case 'balance':
            balance($_REQUEST['DateFrom'], $_REQUEST['DateTo'],$connection);
            exit;
            break;	
        default:
            error(23, 'Невозможно определить тип запроса', $Payment_id);
            exit;
    }
}


error(3, 'Неверный формат запроса', -1);


function balance($DateFrom, $DateTo, $connection)
{
	
	$query = "SELECT `id`,`operation_id`,`contract`,`sum`,`contract`,`date` FROM `operations_rnkb` WHERE `date` BETWEEN ? AND ?;";
    $statement = $connection->prepare($query);
    $statement->execute([GetReadableDate($DateFrom), GetReadableDate($DateTo)]);
    $payments = $statement->fetchAll(PDO::FETCH_ASSOC);
	
	$PAYMENT_ROWS='';
	$FULL_SUMMA=0;
	$NUMBER_OF_PAYMENTS=count($payments);
	
	for ($i = 0; $i < $NUMBER_OF_PAYMENTS; $i++) {		
		$FULL_SUMMA += $payments[$i]['sum'];
		$payments[$i]['date'] = str_replace('-','',$payments[$i]['date']);
		$payments[$i]['date'] = str_replace(':','',$payments[$i]['date']);
		$payments[$i]['date'] = str_replace(' ','',$payments[$i]['date']);
		$PAYMENT_ROWS .= "\n		<PAYMENT_ROW>".$payments[$i]['operation_id'] .';'. $payments[$i]['id'] .';'. $payments[$i]['contract'] .';'. $payments[$i]['sum'] .';'. $payments[$i]['date'].'</PAYMENT_ROW>';
	}
	//<PAYMENT_ROW>9876;55555;12345;1.00;20170101 182810</PAYMENT_ROW>
	
	echo"<BALANCERESPONSE>
	<ERROR>0</ERROR>
	<FULL_SUMMA>$FULL_SUMMA</FULL_SUMMA>
	<NUMBER_OF_PAYMENTS>$NUMBER_OF_PAYMENTS</NUMBER_OF_PAYMENTS>
    <PAYMENTS>$PAYMENT_ROWS
	</PAYMENTS>
</BALANCERESPONSE>";
}



function check($account, $connection)
{
    $query = "SELECT FIO AS name, ballance AS balance, `tarif_guid`, `group_guid` FROM stat WHERE user_name = ? or contract = ?";
    $statement = $connection->prepare($query);
    $statement->execute([$account,$account]);
    $user = $statement->fetch(PDO::FETCH_ASSOC);
    if ($user == false) {
        error(1, 'Идентификатор абонента не найден');
        exit;
    }
	
	$tarif_guid = $user['tarif_guid'];
	$group_guid = $user['group_guid'];
		
	$sql = "SELECT `params` FROM `payment_params` WHERE `type` = 59;";
	$mysqlResult = mysql_query($sql, $GLOBALS["mysql"]);
		
	$RNKB_INN='';
		
	while($row = mysql_fetch_array($mysqlResult)) { 
		
		$Params = GetParams($row[0]);
		
		$RNKBTariffsAndGroups = $Params['RNKBTariffsAndGroups'];
		$RNKBTariffsAndGroups = explode('*',trim($RNKBTariffsAndGroups,'*'));
		
		if ((strlen(array_search($tarif_guid, $RNKBTariffsAndGroups))>0)||(strlen(array_search($group_guid, $RNKBTariffsAndGroups))>0)){
			$RNKB_INN = $Params['RNKB_INN'];
			break;
		}	
	}
	
	if (strlen($RNKB_INN)>0){
		$RNKB_INN="
	<INN>$RNKB_INN</INN>";
	}
	
	$user['balance']=explode(' ',$user['balance']);
	$user['balance']=str_replace(',','.',$user['balance'][0]);

    $response = '<?xml version="1.0" encoding="UTF-8"?>
<CHECKRESPONSE>
	<FIO>'.$user['name'].'</FIO>
	<BALANCE>'.$user['balance'].'</BALANCE>
	<ERROR>0</ERROR>
	<COMMENTS>Success</COMMENTS>'.$RNKB_INN.'
</CHECKRESPONSE> 
';
    echo $response;
}


function pay($Payment_id, $account, $amount, $connection, $Exec_date)
{
	
	$query = "SELECT id FROM operations_rnkb WHERE operation_id = ?";
    $statement = $connection->prepare($query);
    $statement->execute([$Payment_id]);
    $payments = $statement->fetch(PDO::FETCH_ASSOC);
	
	$LastPay=-1;
	$DoPay=true;
	if ($payments != false) {
        $DoPay=false;
		$LastPay=$payments['id'];
    }

    $statement = $connection->prepare("SELECT stat.shortguid FROM stat WHERE user_name = ? or contract = ?");
    $statement->execute([$account,$account]);
    $userId = $statement->fetch(PDO::FETCH_ASSOC);
    if ($userId == false) {
		if ($DoPay){
			$stm = $connection->prepare("INSERT INTO `unknown_payments` (`moneytime`,`cash`,`pay_type`,`comment`) VALUES (?,?,59,?);");
			$stm->execute([time(), $amount, $account]);
		}
        error(1, "Не найден пользователь, невозможно пополнить баланс");
    }

	if ($DoPay){
		$payer = 'RNKB';
		//$dateTime = date("Y-m-d H:i:s");
		$dateTime = $Exec_date;
		$uid = uniqid("", true) . uniqid("", true);
		$statement = $connection->prepare("INSERT INTO addcash2 VALUES (?,?,0,'$payer',0, ?,?,?);");
		$statement->execute([$userId['shortguid'], $amount, $uid, '', $dateTime]);

		$statement = $connection->prepare("INSERT INTO actionslog VALUES (?,'ADD_MONEY',?,?,'',?)");
		$statement->execute([$dateTime, $account, $amount, $payer]);
		
		$statement = $connection->prepare("INSERT INTO `refresh_db` VALUES (1);");
		$statement->execute();

		$query = "INSERT INTO operations_rnkb (`contract`,`sum`,`operation_id`,`date`) VALUES (?,?,?,?)";
		$statement = $connection->prepare($query);
		$statement->execute([$account, $amount, $Payment_id, $dateTime]);
		
		$response = '<?xml version="1.0" encoding="UTF-8"?>
<PAYRESPONSE>
	<ERROR>0</ERROR>
	<OUT_PAYMENT_ID>'.$connection->lastInsertId().'</OUT_PAYMENT_ID>
	<COMMENTS>Success</COMMENTS>
</PAYRESPONSE>';

    echo $response;
	} else {
		echo '<?xml version="1.0" encoding="UTF-8"?>
<PAYRESPONSE>
	<ERROR>10</ERROR>
	<OUT_PAYMENT_ID>'.$LastPay.'</OUT_PAYMENT_ID>
	<COMMENTS>Платёж был проведён ранее</COMMENTS>
</PAYRESPONSE>';
	}
	
    exit;
}


function error($code, $description)
{
    $response = '<?xml version="1.0" encoding="UTF-8"?>
<CHECKRESPONSE>
	<COMMENTS>'.$description.'</COMMENTS>
	<ERROR>'.$code.'</ERROR>
</CHECKRESPONSE>
';
    echo $response;
    exit;
}

function writeToLog($message, $type)
{
    $string = '[' . date("Y:d:m H:i:s") . '] ' . $type . ': ' . $message . PHP_EOL;
    file_put_contents('payin.txt', $string, FILE_APPEND | LOCK_EX);
}

function GetReadableDate($OldDate){
	$Year=substr($OldDate,0,4);
	$Month=substr($OldDate,4,2);
	$Day=substr($OldDate,6,2);
	$Hour=substr($OldDate,8,2);
	$Minute=substr($OldDate,10,2);
	$Second=substr($OldDate,12,2);

	return "$Year-$Month-$Day $Hour:$Minute:$Second";
}