<?php

	$p = xml_parser_create();
	xml_parse_into_struct($p, file_get_contents('php://input'), $vals, $index);
	xml_parser_free($p);

	$MainTag = $vals[0]['tag'];
	$Action = $vals[0]['attributes']['ACTION'];

	if (strlen($Action)==0) {echo "Hello my World!";exit();}

	include_once "../../config.php";
	header('Content-Type: text/xml');

	if ($GLOBALS ["EnableClick2"] != 'True'){exit();}


	if ($GLOBALS ["UseClick2_IPFilter"] == 'True') {
		$allowed_ips = $GLOBALS ['Click2_allowed_ips'];
		if (array_search($_SERVER["REMOTE_ADDR"], $allowed_ips) === false) {	
			echo 'Запрос выполнен из неразрешенного адреса';
			exit();
		}
	}
	
	
	
	//echo 'Tag = ' . $MainTag;
	//echo "\n\n";
	//echo 'Actoin = ' . $Action;
	//echo "\n\n";

	//echo "\nМассив Vals\n";
	//print_r($vals);
	
	
	
	$Out='';
if ($MainTag=='TRANSFER'){
	if ($Action=='Presearch'){
	
		for ($i = 1; $i < count($vals); $i++) {
			if ($vals[$i]['tag']=='UNIT') {
				$Attribs = $vals[$i]['attributes'];
				if ($Attribs['NAME'] == 'ls') {
					$Contract = $Attribs['VALUE'];
					echo GetUserFromContract($Contract, 0, '', 0);
					break;
				}
			}
		}				
	} elseif ($Action=='Search') {
		for ($i = 1; $i < count($vals); $i++) {
			//echo 'Tag=' . $vals[$i]['tag']."\n";
			if ($vals[$i]['tag']=='UNIT') {
				$Attribs = $vals[$i]['attributes'];
				if ($Attribs['NAME'] == 'bill_identifier') {
					$Contract = $Attribs['VALUE'];
					echo GetUserFromContract($Contract, 1, '', 0);
					break;
				}
			} elseif ($vals[$i]['tag']=='DATA') {
				$Attribs = $vals[$i]['attributes'];
				$Contract = $Attribs['PRESEARCHID'];
				if (strlen($Attribs['PRESEARCHID'])>2){
					echo GetUserFromContract($Attribs['PRESEARCHID'], 1, '', 0);
					break;
				}
			}
		}	
	} elseif ($Action=='Check') {
		
		$PaymentID = '';
		$Summ = 0;
		for ($i = 1; $i < count($vals); $i++) {
			if ($vals[$i]['tag']=='DATA') {
				
				$Attribs = $vals[$i]['attributes'];
					
				if (strlen($Attribs['ID'])>5) $PaymentID = $Attribs['ID'];
			} elseif ($vals[$i]['tag']=='TOTALSUM') {
				$Summ = $vals[$i]['value'];
			}
		}
		
		if ((strlen($PaymentID)>0) && ((float)$Summ > 0)){
			for ($i = 1; $i < count($vals); $i++) {
				if ($vals[$i]['tag']=='PAYERINFO') {
					$Attribs = $vals[$i]['attributes'];
					$Contract = $Attribs['BILLIDENTIFIER'];
				 	if (strlen($Contract)<3){$Contract = $Attribs['LS'];}
					echo GetUserFromContract($Contract, 2, $PaymentID, $Summ);
					break;
				}
			}
		}
	} elseif ($Action=='Pay') {
		$PaymentID = '';
		$Summ = 0;
		$ContractLS = '';
		$ContractBI = '';
		
		for ($i = 1; $i < count($vals); $i++) {
			if ($vals[$i]['tag']=='DATA') {
				$Attribs = $vals[$i]['attributes'];
				if (strlen($Attribs['ID'])>0) $PaymentID = $Attribs['ID'];
			} elseif ($vals[$i]['tag']=='TOTALSUM') {
				$Summ = $vals[$i]['value'];
			} elseif ($vals[$i]['tag']=='PAYERINFO') {
				$Attribs = $vals[$i]['attributes'];
				if (strlen($Attribs['LS'])>0) {$ContractLS = $Attribs['LS'];}
				if (strlen($Attribs['BILLIDENTIFIER'])>0){$ContractBI = $Attribs['BILLIDENTIFIER'];}
			}
		}
		
		$Contract=$ContractBI;
		if (strlen($Contract)<3){$Contract = $ContractLS;}
		
		//echo $PaymentID . '<br>';
		//echo $Summ . '<br>';
		//echo $Contract . '<br>';
				
		if ((strlen($PaymentID)>0) && (strlen($Contract)>0) && ((float)$Summ > 0)){
			echo GetUserFromContract($Contract, 3, $PaymentID, $Summ);
		}
	}
}



function GetParam($Name, $Arr){
	foreach ($Arr as $v1) {
		echo $v1.'<br>';
		if ($v1[0]==$Name) {return $Arr[0];}
	}
}

function GetUserFromContract($Contract, $Action, $PaymentID, $Summ) {

	if ($GLOBALS ['Click2SearchOption']=='0') {
		$sql = "SELECT `FIO`, `pinfo`, `shortguid`, `otherinfo`, `FIO`, `ballance` FROM `stat` WHERE (`contract` = '$Contract' or `shortguid` = '$Contract');";
	} else {
		$sql = "SELECT `FIO`, `pinfo`, `shortguid`, `otherinfo`, `FIO`, `ballance` FROM `stat` WHERE (`user_name` = '$Contract' or `shortguid` = '$Contract');";
	}
	$result = mysql_query($sql,$GLOBALS ["mysql"]);
	if ($row = mysql_fetch_array($result)) {
		
		$Name=$row[0];
		$pinfo=$row[1];
		$pinfo=explode('||',$pinfo);
		$tel=$pinfo[0];
		$shortguid=$row[2];
		$otherinfo=explode('||',$row[3]);
		$fio=$row[4];
		$BA=explode(' ',$row[5]);
		$ballance=str_replace(',','.',$BA[0]);
		
		$debt=str_replace(',','.',$otherinfo[74]);
		$credit=str_replace(',','.',$otherinfo[16]);
		$debt2=(float)$ballance - (float)$credit;
				
		if (strlen($Name)==0){$Name = 'Нет имени';}
		
		$FirmName = $GLOBALS ["PortalName"];
	
		if (strlen($fio)>1){$fio = $fio.',';}
	
		if ($Action==0) {
		
			return "<?xml version='1.0' encoding='UTF-8' standalone='yes'?>
<Transfer xmlns='http://debt.privatbank.ua/Transfer' interface='Debt' action='Presearch'>
   <Data xmlns:xsi='http://www.w3.org/2001/XMLSchema-instance' xsi:type='PayersTable'>
      <Headers>
         <Header name='fio'/>
         <Header name='ls'/>
         <Header name='bill_identifier'/>
      </Headers>
      <Columns>
         <Column>
            <Element>$Name</Element>
         </Column>
		 <Column>
            <Element>$Contract</Element>
         </Column>
         <Column>
            <Element>$shortguid</Element>
         </Column>
      </Columns>
   </Data>
</Transfer>";
		} elseif ($Action==1) {
		
			return "<?xml version='1.0' encoding='UTF-8' standalone='yes'?>
<Transfer xmlns='http://debt.privatbank.ua/Transfer' interface='Debt' action='Search'>
   <Data xmlns:xsi='http://www.w3.org/2001/XMLSchema-instance' xsi:type='DebtPack'>
		<PayerInfo billIdentifier='$shortguid' ls='$Contract'>
            <Fio>$Name</Fio>
            <Phone>$tel</Phone>
		</PayerInfo>
      <ServiceGroup>
         <DebtService serviceCode='".$GLOBALS['Click2ServiceID']."'>
            <CompanyInfo>
               <CompanyCode>".$GLOBALS['Click2CompanyID']."</CompanyCode>
            </CompanyInfo>
            <DebtInfo amountToPay='$debt2' debt='$debt'>
				<Balance>$ballance</Balance>
			</DebtInfo>
            <ServiceName>Интернет</ServiceName>
            <Destination>".$GLOBALS['Click2ServiceName'].", $fio$Contract</Destination>
            <PayerInfo billIdentifier='$shortguid' ls='$Contract'>
               <Fio>$Name</Fio>
               <Phone>$tel</Phone>
            </PayerInfo>
         </DebtService>
      </ServiceGroup>
   </Data>
</Transfer>";
		}  elseif ($Action==2) {
			
			$datetoday = date("Y-m-d H:i:s");		
			$sql = "INSERT INTO operations_2click (`sum`,`operation_id`,`status`,`actiondate`) VALUES($Summ,'$PaymentID','2','$datetoday');";
			mysql_query($sql,$GLOBALS ["mysql"]);
			
			return "<?xml version='1.0' encoding='UTF-8' standalone='yes'?>
<Transfer xmlns='http://debt.privatbank.ua/Transfer' interface='Debt' action='Check'>
<Data xmlns:xsi='http://www.w3.org/2001/XMLSchema-instance' xsi:type='Gateway' reference='".mysql_insert_id()."' />
</Transfer>";
		}  elseif ($Action==3) {
			
			$sql = "SELECT `operation_id`, `status` FROM `operations_2click` WHERE `operation_id` = '$PaymentID' and `status` = 0";
			$result = mysql_query($sql,$GLOBALS ["mysql"]);
			if (mysql_num_rows($result)==0) {
			
				$sql = "SELECT `id`, `operation_id`, `status` FROM `operations_2click` WHERE `operation_id` = '$PaymentID' and `status` = 2";
				$result = mysql_query($sql,$GLOBALS ["mysql"]);

				if (mysql_num_rows($result)>0) {
					$row = mysql_fetch_array($result);
					
					echo "<?xml version='1.0' encoding='UTF-8' standalone='yes'?>
<Transfer xmlns='http://debt.privatbank.ua/Transfer' interface='Debt' action='Pay'>
<Data xmlns:xsi='http://www.w3.org/2001/XMLSchema-instance' xsi:type='Gateway' reference='".$row[0]."'>
</Data>
</Transfer>";
					
					$datetoday = date("Y-m-d H:i:s");	
					$sql = "INSERT INTO operations_2click (`sum`,`operation_id`,`status`,`actiondate`) VALUES($Summ,'$PaymentID','0','$datetoday');";
					mysql_query($sql,$GLOBALS ["mysql"]);
					$GUID = uniqid("",true);
					$sql="INSERT INTO `addcash2` VALUES ('$shortguid', $Summ, 0, '2CLICK', '0', '$GUID','','$datetoday');";
					$result = mysql_query($sql,$GLOBALS ["mysql"]);
					mysql_query("INSERT INTO `refresh_db` VALUES (1);",$GLOBALS ["mysql"]);
					return "";
				} else {
					return "<?xml version='1.0' encoding='UTF-8' standalone='yes'?>
<Transfer xmlns='http://debt.privatbank.ua/Transfer' interface='Debt' action='Pay'>
<Data xmlns:xsi='http://www.w3.org/2001/XMLSchema-instance' xsi:type='ErrorInfo' code='3'>
<Message>Платёж не найден!</Message>
</Data>
</Transfer>
";
				}
			} else {
			
				return "<?xml version='1.0' encoding='UTF-8' standalone='yes'?>
<Transfer xmlns='http://debt.privatbank.ua/Transfer' interface='Debt' action='Pay'>
<Data xmlns:xsi='http://www.w3.org/2001/XMLSchema-instance' xsi:type='ErrorInfo' code='3'>
<Message>Платёж уже проведён!</Message>
</Data>
</Transfer>
";
			}
			
			
		}
	} else {
		
		if ($Action==3) {
			$sql="INSERT INTO `unknown_payments` (`moneytime`,`cash`,`pay_type`,`comment`) VALUES ('".time()."', $Summ, 48, '$Contract');";
			mysql_query($sql,$GLOBALS ["mysql"]);
		}
		
		return "<?xml version='1.0' encoding='UTF-8' standalone='yes'?>
<Transfer xmlns='http://debt.privatbank.ua/Transfer' interface='Debt' action='Search'>
<Data xmlns:xsi='http://www.w3.org/2001/XMLSchema-instance' xsi:type='ErrorInfo' code='2'>
<Message>Абонент не найден</Message>
</Data>
</Transfer>";
	}
}
	

?>