<?php
//error_reporting(E_ALL);
//ini_set('display_errors', 1);
include_once "../../config.php";
include_once "../../smalldbcore.php";


if (!isset($_REQUEST['PAY_ID'])){
	echo "Hello my World!";
	exit();
}

if ($GLOBALS ["UseEasypay_IPFilter"] == 'True') {
	$allowed_ips = $GLOBALS ['Easypay_allowed_ips'];
	if (array_search($_SERVER["REMOTE_ADDR"], $allowed_ips) === false) {
		echo("Запрос выполнен с неразрешенного IP адреса!");
		exit();
	}
}


function myout($s){
	die($s);
}

function valInt($v){
	return is_numeric($v) ? intval($v) : 0;
}
function valFloat($v){
	return is_numeric($v) ? floatval($v) : 0.0;
}
function bad_ret($errId){
	$date = date('d.m.Y H:i:s');
	myout("<?xml version=\"1.0\" encoding=\"UTF-8\"?>
<pay-response>
 <status_code>$errId</status_code>
 <time_stamp>$date</time_stamp>
</pay-response>");
}

if ($GLOBALS ["EnableCitypay"] <> "True") {exit();}

$SECRET=$GLOBALS["CitypaySecrertWord"];
$SERV_ID=$GLOBALS["CitypayService"];
$ACT=valInt($_REQUEST['ACT']);
if($ACT <= 0) bad_ret(-101);
$PAY_AMOUNT=valFloat($_REQUEST['PAY_AMOUNT']);
$PAY_ACCOUNT=isset($_REQUEST['PAY_ACCOUNT']) ? $_REQUEST['PAY_ACCOUNT'] : '';
$PAY_ID=isset($_REQUEST['PAY_ID']) ? $_REQUEST['PAY_ID'] : '';
$RECEIPT_NUM=valInt($_REQUEST['RECEIPT_NUM']);
$TRADE_POINT=isset($_REQUEST['TRADE_POINT']) ? $_REQUEST['TRADE_POINT'] : '';

$SIGN='';
if(isset($_REQUEST['SIGN'])){
	$SIGN = strtolower($_REQUEST['SIGN']);
}

$our_sign = md5(join('_', array($ACT, $PAY_ACCOUNT, isset($_REQUEST['SERVICE_ID'])?$_REQUEST['SERVICE_ID']:'', $PAY_ID, $SECRET)));
$date = date('d.m.Y H:i:s');

if($our_sign != $SIGN){
	bad_ret(-101);
}


if($ACT == 1){

	$login = mysql_real_escape_string($PAY_ACCOUNT);
	$sql = "SELECT FIO, ballance FROM stat WHERE user_name = '$login' LIMIT 1";
	$result = mysql_query($sql, $mysql);

	if(mysql_num_rows($result) == 0){
		mysql_free_result($result);
		bad_ret(-40);
	}

	$row = mysql_fetch_array($result);
	mysql_free_result($result);

	$fio = &$row['FIO'];

	$blnc = valInt(substr($row['ballance'], 0, -5));

	/*if($blnc <= 0){
		bad_ret(-101);
	}*/
	myout("<?xml version=\"1.0\" encoding=\"UTF-8\"?>
<pay-response>
  <balance>$blnc</balance>
  <name>$fio</name>
  <account>$login</account>
  <service_id>$SERV_ID</service_id>
  <min_amount>10.0</min_amount>
  <max_amount>50000</max_amount>
  <status_code>21</status_code>
  <time_stamp>$date</time_stamp>
</pay-response>");

}else if($ACT == 4){

	$login = mysql_real_escape_string($PAY_ACCOUNT);
	$sql = "SELECT shortguid FROM stat WHERE user_name = '$login' AND `isarchived` = 0 LIMIT 1";
	$result = mysql_query($sql, $mysql);
	if(mysql_num_rows($result) == 0){
		mysql_free_result($result);
		$sql="INSERT INTO `unknown_payments` (`moneytime`,`cash`,`pay_type`,`comment`) VALUES ('".time()."', ". $PAY_AMOUNT .", 12, '$login');";
		mysql_query($sql,$GLOBALS ["mysql"]);
		
		bad_ret(-40);
	}
	$row = mysql_fetch_array($result);
	$shortguid = &$row['shortguid'];
	mysql_free_result($result);


	$sql = "SELECT `sum` FROM `operations_citypay` WHERE `id`='$PAY_ID' and `status` = 0";
	$result = mysql_query($sql, $mysql);
	if(mysql_num_rows($result) > 0){
		bad_ret(-100);
	}
	mysql_free_result($result);
	$sql = "INSERT INTO `operations_citypay` (`sum`,`operation_id`,`status`,`actiondate`) VALUES ($PAY_AMOUNT, '$PAY_ID', 0, now())";
	$result = mysql_query($sql, $mysql);
	if($result != true){
		bad_ret(-90);
	}
	mysql_free_result($result);

	$cash = &$PAY_AMOUNT;
	$GUID = uniqid("",true);
	$sql="INSERT INTO addcash2 VALUES ($shortguid, $cash, 0.0, 'Citypay', 0, '$GUID','',NOW())";
	$result = mysql_query($sql, $mysql);
	if($result != true){
		bad_ret(-90);
	}
	mysql_free_result($result);
	
	//$sql = "INSERT INTO workparams VALUES('REFRESH_DB','');";
	$sql = "INSERT INTO `refresh_db` VALUES (1);";
	mysql_query($sql,$mysql);
	
	myout("<?xml version=\"1.0\" encoding=\"UTF-8\"?><pay-response>
 <pay_id>$PAY_ID</pay_id>
 <service_id>$SERV_ID</service_id>
 <amount>$PAY_AMOUNT</amount>
 <status_code>22</status_code>
 <time_stamp>$date</time_stamp>
</pay-response>");

}else if($ACT == 7){
	$sql = "SELECT `actiondate`, `sum` FROM `operations_citypay` WHERE `id`='$PAY_ID' and `status` = 0";
	$result = mysql_query($sql, $mysql);

	if(mysql_num_rows($result) == 0){
		mysql_free_result($result);
		bad_ret(-10);
	}
	$row = mysql_fetch_array($result);
	mysql_free_result($result);


	$dat_add = date( 'd.m.Y H:i:s', strtotime($row['date_add']) );

	$sum = &$row['sum'];

	myout("<?xml version=\"1.0\" encoding=\"UTF-8\"?>
<pay-response>
 <status_code>11</status_code>
 <time_stamp>$dat_add</time_stamp>
 <transaction>
  <pay_id>$PAY_ID</pay_id>
  <service_id>$SERV_ID</service_id>
  <amount>$sum</amount>
  <status>111</status>
  <time_stamp>$dat_add</time_stamp>
 </transaction>
</pay-response>");
}else{
	bad_ret(-101);
}

?>