<?php
include_once '../../config.php';
include './HayPost.php';

	$request = file_get_contents('php://input');
	doLog($request);
	if (strlen($request)==0){echo "Hello my World!";exit();}

	if ($GLOBALS ["EnableHayPost"] <> "True") {exit();}

	if ($GLOBALS ["UseHayPost_IPFilter"] == 'True') {
		$allowed_ips = $GLOBALS ['HayPost_allowed_ips'];
		if (array_search($_SERVER["REMOTE_ADDR"], $allowed_ips) === false) {
			http_response_code(403);
			exit();
		}
	}


$json = json_decode($request);
$inputData = $json->Input_data;
$GoodToken = $GLOBALS ["HayPostToken"];

try {
    $mAddr = explode(":", $GLOBALS['mysql_adr']);
    $connection = new PDO("mysql:host=" . $mAddr[0] . ";port=" . $mAddr[1] . ";dbname=" . $GLOBALS['mysql_db'], $GLOBALS['mysql_user'], $GLOBALS['mysql_pass']);
    $connection->exec("SET NAMES utf8");
} catch (Exception $e) {
    echo 'Невозможно установить соединение с БД' . PHP_EOL;
    $e->getMessage();
    exit;
}

$hayPost = new HayPost($connection);

switch ($inputData->method) {
    case 'check_debt':
        $response = $hayPost->checkDept($inputData->contractId, $inputData->token, $GLOBALS["HayPostToken"]);
        doLog($response);
        echo $response;
        break;
    case 'pay':
        $response = $hayPost->pay($inputData->contractId, $inputData->amount, $inputData->transactionId, $inputData->pat_date, $inputData->token, $GLOBALS["HayPostToken"]);
        doLog($response);
        echo $response;
        break;
    case 'pay_cancel':
        $response = $hayPost->pay($inputData->contractId, $inputData->amount, $inputData->transactionId, $inputData->pat_date, $inputData->paymentId);
        doLog($response);
        echo $response;
        break;
    default:
        $response = $hayPost->error('Неверный формат запроса');
        doLog($response);
        echo $response;
}

function doLog($message)
{
    //if (ENABLE_LOG) {
        file_put_contents('payin.txt', date('d.m.Y H:i:s  ') . $message . PHP_EOL, FILE_APPEND | LOCK_EX);
    //}
}
?>