<?php
	
	include_once "../../config.php";
	include_once "../../smalldbcore.php";
	
	if ($GLOBALS ["EnablePayMe"] <> '1') {exit();}
	
	$fp = fopen("payin.txt", "a");
	fputs($fp, "\n\nDate = " . date("d.m.y H:i:s")."\n");
	fputs($fp,  print_r($_REQUEST, true));
	
	if ($GLOBALS ["UsePayMe_IPFilter"] == 'True') {
		$allowed_ips = $GLOBALS['PayMe_allowed_ips'];
		if (array_search($_SERVER["REMOTE_ADDR"], $allowed_ips) === false) {
			echo("Запрос выполнен с неразрешенного IP адреса!");
			exit();
		}
	}
	
	$TokenFinded = false;
	$Token = '';
	foreach (getallheaders() as $name => $value) {
		if ($name=='Authorization'){
			
			$TokenFinded = true;
			$Token = substr($value, 6);
			
			fputs($fp, 'Token = ' . $Token."\n");
			
			Process($Token);
			
		}
	}
	
	if (!$TokenFinded){
		$request = file_get_contents('php://input');
		$json = json_decode($request,true);
		
		$id=(isset($json['id'])?($json['id']):(-1));
		SendError('Hello my world!',-32504,$id);
	}
	
	
	function Process($Token){
		$request = file_get_contents('php://input');
		//WriteToLog($request);
		
		$fp = fopen("payin.txt", "a");
		fputs($fp, "Request = " . $request."\n");
		
		$json = json_decode($request,true);
		
		$PayMeTokens=array();
		$PayMe_ID=array();
		$PayMe_MerchantID=array();
		$PayMe_KEY=array();
		
		$PayMe_PrintReceipt=array();
		$PayMe_ReceiptTitle=array();
		$PayMe_vat_percent=array();
		$PayMe_ikpu=array();
		$PayMe_package_code=array();
		
		
		$sql = "SELECT `params`, `id` FROM `payment_params` WHERE `type` = 51;";
		$mysqlResult = mysql_query($sql,$GLOBALS ["mysql"]);
		if (mysql_num_rows($mysqlResult)>0){
			while($row = mysql_fetch_array($mysqlResult)) { 
				$Params = GetParams($row[0]);
				
				$PayMe_ID[]=$row[1];
				$PayMe_MerchantID[] = $Params['PayMe_MerchantID'];
				$PayMe_KEY[] = $Params['PayMe_KEY'];
				$PayMeTokens[]=base64_encode('Paycom:'.$Params['PayMe_KEY']);

				if (isset($Params['PayMe_PrintReceipt'])){$PayMe_PrintReceipt[]=$Params['PayMe_PrintReceipt'];}else{$PayMe_PrintReceipt[]=0;}
				if (isset($Params['PayMe_ReceiptTitle'])){$PayMe_ReceiptTitle[]=$Params['PayMe_ReceiptTitle'];}else{$PayMe_ReceiptTitle[]='Internet payment';}
				if (isset($Params['PayMe_vat_percent'])){$PayMe_vat_percent[]=$Params['PayMe_vat_percent'];}else{$PayMe_vat_percent[]=15;}
				if (isset($Params['PayMe_ikpu'])){$PayMe_ikpu[]=$Params['PayMe_ikpu'];}else{$PayMe_ikpu[]=0;}
				if (isset($Params['PayMe_package_code'])){$PayMe_package_code[]=$Params['PayMe_package_code'];}else{$PayMe_package_code[]=0;}
			}
		}
		
		
		$ind=array_search($Token, $PayMeTokens);
		if (strlen($ind===false)){
			fputs($fp, "Bad auth! \n");
			fputs($fp, "Tokens = " . print_r($PayMeTokens,true));
			SendError('Bad auth!',-32504,$json['id']);
		} 
		
		$PayMe_ID=$PayMe_ID[$ind];
		$PayMe_MerchantID=$PayMe_MerchantID[$ind];
		$PayMe_KEY=$PayMe_KEY[$ind];
		$PayMeTokens=$PayMeTokens[$ind];
		
		$PayMe_PrintReceipt=$PayMe_PrintReceipt[$ind];
		$PayMe_ReceiptTitle=$PayMe_ReceiptTitle[$ind];
		$PayMe_vat_percent=$PayMe_vat_percent[$ind];
		$PayMe_ikpu=$PayMe_ikpu[$ind];
		$PayMe_package_code=$PayMe_package_code[$ind];
		
		$GLOBALS['PayMe_ID']=$PayMe_ID;
		
		$ShortGUID = -1;
		
		if ($json['method']=='CheckPerformTransaction'){
			$a=array_values($json['params']['account']);
			$a=array_shift($a);
			if (CheckUser($a,$json['params']['amount'],$json['id'])>0){
				
				$out=array();
				
				if ($PayMe_PrintReceipt == 1){
					
					$out=array('detail' => array('items' => array('title' => $PayMe_ReceiptTitle, 'price' => (float)$json['params']['amount'], 'count' => 1, 'code' => (int)$PayMe_ikpu,
																   'vat_percent' =>(int)$PayMe_vat_percent, 'package_code' => (int)$PayMe_package_code)),
												'result' => array('allow' => true), 'id' => $json['id']);
				} else {
					$out=array('result' => array('allow' => true), 'id' => $json['id']);
				}

				echo (json_encode($out));

			}
		} elseif ($json['method']=='CreateTransaction') {
			$a=array_values($json['params']['account']);
			$a=array_shift($a);
			if (($ShortGUID = CheckUser($a,$json['params']['amount'],$json['id'])) > 0){
				CheckTransaction($ShortGUID,$json['params']['id'],$json['params']['amount'],0,$json['id']);
			}
		} elseif ($json['method']=='PerformTransaction') {
			$tID = CheckTransaction($ShortGUID,$json['params']['id'],0,1,$json['id']);
			if ($tID > -1){
				MakePayment($json['params']['id'],false,$json['id']);
			} else {SendError('Транзакция не найдена!', -31003,$json['id']);}
		}elseif ($json['method']=='CancelTransaction') {
			$tID = CheckTransaction($ShortGUID,$json['params']['id'],$json['params']['amount'],2,$json['id']);
			if ($tID > -1){
				MakePayment($json['params']['id'],true,$json['id']);
			} else {SendError('Транзакция не найдена!', -31003,$json['id']);}
		}elseif ($json['method']=='CheckTransaction') {	
			CheckTransaction($ShortGUID,$json['params']['id'],$json['params']['amount'],3,$json['id']);
		}elseif ($json['method']=='ChangePassword') {	
			$NewKEY = $json['params']['password'];
			$sql = "UPDATE `payment_params` SET `params` = '" . mysql_real_escape_string('PayMe_MerchantID||'.$PayMe_MerchantID.'||PayMe_KEY||'.$NewKEY)."' WHERE `id` = $PayMe_ID;";
			mysql_query($sql,$GLOBALS ["mysql"]);
			$datetoday = date("Y-m-d H:i:s");
			$uid = uniqid("");
			$sql = "INSERT INTO `actions` VALUES ('REREAD_PAYMENTS_PARAMS','','$datetoday','','$uid');";
			mysql_query($sql,$GLOBALS ["mysql"]);
			mysql_query("INSERT INTO `refresh_db` VALUES (1);",$GLOBALS ["mysql"]);
			echo 
'{
    "result" : {
		"time" : '. (time()*1000) .',
        "message" : "OK"
    },
    "id" : '.$ID.'
}';
		}else {
			SendError('Неизвестный метод!', -31055,$json['id']);
		}
	}
	
	function CheckUser($UsrID, $Amount,$ID){

		$sql = "SELECT `shortguid` FROM `stat` WHERE `user_name` = '".mysql_real_escape_string($UsrID)."'";
		$fp = fopen("payin.txt", "a");
		//fputs($fp, "SQL = " . $sql."\n");
		$result = mysql_query($sql,$GLOBALS ["mysql"]);

		if (mysql_num_rows($result)>0){
			if ($Amount >= $GLOBALS['PayMe_MinPlat']){
				$row = mysql_fetch_array($result);
				return $row[0];
			} else {SendError('Сумма оплаты слишком мала!', -31001,$ID);}
		} else {SendError('Абонент не найден!', -31050,$ID);}
		return -1;
	}
	
	function MakePayment($PaymentID, $CancelPayment, $ID){
		$sql = "SELECT `id`, `contract`, `sum`, `date`, `status`,`perform_time`,`cancel_time` FROM `operations_paycomuz` WHERE `operation_id` = '".mysql_real_escape_string($PaymentID)."';";
		$result = mysql_query($sql,$GLOBALS ["mysql"]);
		
		$status=0;
		$perform_time=0;
		$cancel_time=0;
		
		if (mysql_num_rows($result)>0){
			$row = mysql_fetch_array($result);
			$status=$row[4];
			
			if ($row[5]=='0000-00-00 00:00:00'){$row[5]='1970-01-01 00:00:01';}
			if ($row[6]=='0000-00-00 00:00:00'){$row[6]='1970-01-01 00:00:01';}
			
			$perform_time=strtotime($row[5])*1000;
			$cancel_time=strtotime($row[6])*1000;
		}

		if (!$CancelPayment){
			if ($status==1){
				$perform_time = date("Y-m-d H:i:s");
				$sql = "UPDATE `operations_paycomuz` SET `status` = 2, `perform_time` = '$perform_time' WHERE `id` = " . $row[0].';';
				mysql_query($sql,$GLOBALS ["mysql"]);
				$perform_time = strtotime($perform_time)*1000;
				$status=2;
				
				$shortguid = $row[1];
				$Summ = $row[2]/100;
				$GUID = uniqid("",true);
				$datetoday = date("Y-m-d H:i:s");
				
				$PayMe_ID = $GLOBALS['PayMe_ID'];
				
				$sql="INSERT INTO `addcash2` VALUES ('$shortguid', $Summ, 0, 'PAYME~~$PayMe_ID', '0', '$GUID','','$datetoday');";
				$result = mysql_query($sql,$GLOBALS ["mysql"]);
				mysql_query("INSERT INTO `refresh_db` VALUES (1);",$GLOBALS ["mysql"]);
			}
		} else {
			if ($status==1){
				$cancel_time = date("Y-m-d H:i:s");
				$sql = "UPDATE `operations_paycomuz` SET `status` = -1, `cancel_time` = '$cancel_time' WHERE `id` = " . $row[0].';';
				mysql_query($sql,$GLOBALS ["mysql"]);
				$cancel_time = strtotime($cancel_time)*1000;
				$status=-1;
			} elseif ($status==2){
				$cancel_time = date("Y-m-d H:i:s");
				$sql = "UPDATE `operations_paycomuz` SET `status` = -2, `cancel_time` = '$cancel_time' WHERE `id` = " . $row[0].';';
				mysql_query($sql,$GLOBALS ["mysql"]);
				$cancel_time = strtotime($cancel_time)*1000;
				$status=-2;
				
				$shortguid = $row[1];
				$Summ = -$row[2]/100;
				$GUID = uniqid("",true);
				$datetoday = date("Y-m-d H:i:s");
				
				$sql="INSERT INTO `addcash2` VALUES ('$shortguid', $Summ, 0, 'PAYME', '0', '$GUID','Refund','$datetoday');";
				$result = mysql_query($sql,$GLOBALS ["mysql"]);
				mysql_query("INSERT INTO `refresh_db` VALUES (1);",$GLOBALS ["mysql"]);
			} 
		}
		
		if (!$CancelPayment){
			echo 
'{
    "result" : {
        "transaction" : "'.$row[0].'",
        "perform_time" : ' . $perform_time .',
        "state" : ' . $status . '
    },
    "id" : '.$ID.'
}';
		}else {
			echo 
'{
    "result" : {
        "transaction" : "'.$row[0].'",
        "perform_time" : ' . $perform_time .',
		"cancel_time" : ' . $cancel_time .',
        "state" : ' . $status . '
    },
    "id" : '.$ID.'
}';			
		}
	}
	
	function CheckTransaction($ShortGUID,$PaymentID,$Summ,$State,$ID){
		$sql = "SELECT `id`, `date`, `status`,`perform_time`,`cancel_time`, `contract` FROM `operations_paycomuz` WHERE `operation_id` = '".mysql_real_escape_string($PaymentID)."'";
		$result = mysql_query($sql,$GLOBALS ["mysql"]);
		$tID=-1;
		$Status=0;
		$Reason='null';
		
		if (mysql_num_rows($result)==0){
			
			//if ($State>-1){
				$sql = "SELECT `id`, `date`, `status`,`perform_time`,`cancel_time`, `contract` FROM `operations_paycomuz` WHERE `contract` = '".mysql_real_escape_string($ShortGUID)."' and `status` >= 0 and `status` < 2 GROUP BY `date` DESC;";
				$result = mysql_query($sql,$GLOBALS ["mysql"]);

				if (mysql_num_rows($result)>0){
					$row = mysql_fetch_array($result);
					
					if ($row[1]=='0000-00-00 00:00:00'){$row[1]='1970-01-01 00:00:01';}
					
					if (((time()-strtotime($row[1]))<10)&&($State==0)){
						SendError('Невозможно выполнить операцию',-31099,$ID);
					}
				}
				$datetoday = date("Y-m-d H:i:s");
				$PaymentID = mysql_real_escape_string($PaymentID);
				$Summ = mysql_real_escape_string($Summ);
				$sql = "INSERT INTO `operations_paycomuz` (`contract`,`sum`,`operation_id`,`date`,`status`,`perform_time`,`cancel_time`) VALUES($ShortGUID,$Summ,'$PaymentID','$datetoday','1','0000-00-00 00:00:00','0000-00-00 00:00:00');";
				mysql_query($sql,$GLOBALS ["mysql"]);
				$tID = mysql_insert_id();
				$datetoday = strtotime($datetoday)*1000;
				$Status=1;
			//}
		} else{
			
			$perform_time=0;
			$cancel_time=0;
			$datetoday = 0;
			
			if (mysql_num_rows($result)>0){
				$row = mysql_fetch_array($result);
				
				if ($row[3]=='0000-00-00 00:00:00'){$row[3]='1970-01-01 00:00:01';}
				if ($row[4]=='0000-00-00 00:00:00'){$row[4]='1970-01-01 00:00:01';}
				if ($row[1]=='0000-00-00 00:00:00'){$row[1]='1970-01-01 00:00:01';}
				
				$tID = $row[0];
				$Status=$row[2];
				$perform_time=strtotime($row[3])*1000;
				$cancel_time=strtotime($row[4])*1000;
				$datetoday = strtotime($row[1])*1000;
			}
			
			if (strlen($perform_time)==0){$perform_time=0;}
			if (strlen($cancel_time)==0){$cancel_time=0;}
			if ((int)$Status<0){
				if ((int)$Status==-1){
					$Reason='3';
				} else {
					$Reason='5';
				}
			}
		}
		
		if ($State==3){
			echo 
'{
    "result" : {
        "create_time" : '.$datetoday.',
        "transaction" : "'.$tID.'",
        "state" : '.$Status.',
		"perform_time" : '.$perform_time.',
		"cancel_time" : '.$cancel_time.',
		"reason" : '.$Reason.'
    },
    "id" : '.$ID.'
}';
		} elseif ($State==0){
			echo 
'{
    "result" : {
        "create_time" : '.$datetoday.',
        "transaction" : "'.$tID.'",
        "state" : '.$Status.'
    },
    "id" : '.$ID.'
}';
		}
		return $tID;
	}
	
	function SendError($MSG, $ErrN, $ID){
		echo 
'{
    "error" : {
		"code": '.$ErrN.',
		"message": {
			"ru" : "'.$MSG.'",
			"uz" : "'.$MSG.'",
            "en" : "'.$MSG.'"
		},
        "data" : "account"
    },
    "id" : '.$ID.'
}';
		$fp = fopen("payin.txt", "a");
		fputs($fp, "Sended Error '$MSG'! \n");
		exit();
	}
	
	function GetParams($ParamsString){
		$Ret=array();
		$ParamsA = explode("||",$ParamsString);
		for ($i = 0; $i < count($ParamsA)-1; $i+=2) {
			$Ret[$ParamsA[$i]]=$ParamsA[$i+1];
		}
		return $Ret;
	}
?>