<?php

	if (!isset($_REQUEST['_payform_sign'])){echo "Hello my World!";exit();}
		
	include_once "../../config.php";
	include_once "../../smalldbcore.php";
	include_once "../../smallfunc.php";
	
	if ($GLOBALS ["UseProdamus"] <> "True") {exit();}
		
	if ($GLOBALS ["UseProdamus_IPFilter"] == 'True') {
		$allowed_ips = $GLOBALS ['Prodamus_allowed_ips'];
		if (array_search($_SERVER["REMOTE_ADDR"], $allowed_ips) === false) {
			echo("Запрос выполнен с неразрешенного IP адреса!");
			exit();
		}
	}

define('STATUS_PENDING', 0);
define('STATUS_PAID', 1);
define('STATUS_ERROR', 2);



////////////////////////////////

$payform_data = array ();

array_walk ( $_GET, function( &$v, $k ) use( &$payform_data ) {
    if ( preg_match('~^_payform_(.*)$~', $k, $m))
        $payform_data[$k] = $v;
});

$payform_data_sign = isset ( $payform_data['_payform_sign'] ) ? $payform_data['_payform_sign'] : '';

$fp = fopen("payin.txt", "a");
fputs($fp, "\n\nDate = " . date("d.m.y H:i:s")."\n");
fputs($fp,  print_r($_REQUEST, true));

unset ( $payform_data['_payform_sign'] );

if ( ! empty ( $payform_data ) ) {
    try {
        if ( empty ( $payform_data_sign ) )
            throw new Exception('Отсутствует подпись передаваемых данных' );

        if ( ! isset ( $payform_data['_payform_status'] ) )
            throw new Exception( 'Ошибка передаваемых данных. Не указан результат оплаты.' );

        if ( ! in_array ( $payform_data['_payform_status'], array ('success') ) )
            throw new Exception( 'Ошибка передаваемых данных. Неизвестный результат оплаты.' );

        if ( 'success' == $payform_data['_payform_status'] ) {
            try {
                $attr = explode(':',$GLOBALS['mysql_adr']);
                $connection = new PDO("mysql:host=".$attr[0].";port=".$attr[1].";dbname=" . $GLOBALS['mysql_db'], $GLOBALS['mysql_user'], $GLOBALS['mysql_pass'], [PDO::ATTR_DEFAULT_FETCH_MODE => PDO::FETCH_ASSOC]);
                $connection->exec("SET NAMES utf8");
            } catch (Exception $e) {
                file_put_contents('errors.txt', date('Y-m-d H:i:s').' '.$e->getMessage().PHP_EOL, FILE_APPEND);
                exit;
            }

            $dateTime = date("Y-m-d H:i:s");
            $value1 = '';
            $uid = uniqid("", true);

            try {

                $stm = $connection->query("SELECT * FROM `operations_prodamus` WHERE `id` = " . (int) $payform_data['_payform_order_id'] . " and `status` = " . STATUS_PENDING);
                $stm->execute();
                $row = $stm->fetchAll();
				
                if (count($row)==1){

                    $order = array_shift( $row );
					
					
					$stm = $connection->query("SELECT `otherinfo` FROM `stat` WHERE `shortguid` = " . $order['shortguid'] . ";");
					$stm->execute();
					$row = $stm->fetchAll();
					
					if (count($row)==1){
						
						$usr = array_shift( $row );
						$otherinfo = explode("||",$usr['otherinfo']);
						
						$ProdamusShopURL = '';
						$ProdamusShopKey = '';
						
						$ProdamusID = $otherinfo[129];
						if ((int)$ProdamusID >-1){
							$sql = "SELECT `params` FROM `payment_params` WHERE `id` = '$ProdamusID';";
							$mysqlResult = mysql_query($sql,$mysql);
							if (mysql_num_rows($mysqlResult)>0){
								$row = mysql_fetch_array($mysqlResult);
								$Params = GetParams($row[0]);

								$ProdamusShopURL = $Params['ProdamusShopURL'];
								$ProdamusShopKey = $Params['ProdamusShopKey'];
							}
						} else  {
							$sql = "SELECT `params`,`id` FROM `payment_params` WHERE `type` = 38;";
							$mysqlResult = mysql_query($sql,$mysql);
							if (mysql_num_rows($mysqlResult)>0){
								$row = mysql_fetch_array($mysqlResult);
								$Params = GetParams($row[0]);
								$ProdamusID=$row[1];

								$ProdamusShopURL = $Params['ProdamusShopURL'];
								$ProdamusShopKey = $Params['ProdamusShopKey'];
							}
						}
						
						
						if ( !Hmac::verify( $payform_data, $ProdamusShopKey, $payform_data_sign) )
							throw new Exception( 'Ошибка подписи передаваемых данных' );

						$stm = $connection->prepare("INSERT INTO addcash2 VALUES (?,?,0,'PRODAMUS~~$ProdamusID',0, ?, ?,?);");
						$stm->execute([$order['shortguid'], $order['amount'], $uid, $value1, $dateTime]);

						$stm = $connection->prepare("INSERT INTO actionslog VALUES (?,'ADD_MONEY',?,?,'',?)");
						$stm->execute([$dateTime, $order['user_name'], $order['amount'], $value1]);

						$query = "UPDATE `operations_prodamus` SET `status` = ? , `prodamus_id` = ? , `date_success` = ? WHERE `id` = ?";
						$stm = $connection->prepare($query);
						$stm->execute([STATUS_PAID, (int) $payform_data['_payform_id'], $dateTime, (int) $order['id']]);
						
						$stm = $connection->prepare("INSERT INTO `refresh_db` VALUES (1);");
						$stm->execute();
					} else {
						$stm = $connection->prepare("INSERT INTO `unknown_payments` (`moneytime`,`cash`,`pay_type`,`comment`) VALUES (?,?,38,?);");
						$stm->execute([time(), $order['amount'], $order['shortguid']]);
					}
						
                }
            }catch (PDOException $e){
				//echo ($e->getMessage());
                file_put_contents('errors.txt', date('Y-m-d H:i:s').' '.$e->getMessage().PHP_EOL, FILE_APPEND);
            }
	
            header('Location: ' . $PortalAddress);
        }
    }
    catch ( Exception $e ) {
		file_put_contents('errors.txt', date('Y-m-d H:i:s').' '.$e->getMessage().PHP_EOL, FILE_APPEND);
        exit();
    }
}

class Hmac {
    static function create($data, $key, $algo = 'sha256') {
        if (!in_array($algo, hash_algos()))
            return false;
        $data = (array) $data;
        array_walk_recursive($data, function(&$v){
            $v = strval($v);
        });
        self::_sort($data);
        if (version_compare(PHP_VERSION, '5.4.0', '<')) {
            $data = preg_replace_callback('/((\\\u[01-9a-fA-F]{4})+)/', function ($matches) {
                return json_decode('"'.$matches[1].'"');
            }, json_encode($data));
        }
        else {
            $data = json_encode($data, JSON_UNESCAPED_UNICODE);
        }
        return hash_hmac($algo, $data, $key);
    }

    static function verify($data, $key, $sign, $algo = 'sha256') {
        $_sign = self::create($data, $key, $algo);
        return ($_sign && (strtolower($_sign) == strtolower($sign)));
    }

    static private function _sort(&$data) {
        ksort($data, SORT_REGULAR);
        foreach ($data as &$arr)
            is_array($arr) && self::_sort($arr);
    }
}
?> 