<?php
require('./template/functions.php');

session_start();

if (!$_SESSION['auth']) {
    header('location: login.php');
}

if (isset($_POST['login_out'])) {
    logout();
}

if ($GLOBALS['EnableROBOKASSA']=='True'){

	if ((strlen(array_search($_SESSION['tarif_guid'], $GLOBALS['ROBOKASSA_allowed_objects']))==0) and
			(strlen(array_search($_SESSION['group_guid'], $GLOBALS['ROBOKASSA_allowed_objects']))==0) and
			(strlen(array_search(12211221122112, $GLOBALS['ROBOKASSA_allowed_objects']))==0)) {
		exit();
	}	
} else {exit();}


$result = getuserinfo();
$result['page_title'] = 'ROBOKASSA';

$Title = ($GLOBALS['UseROBOKASSA_StdTitle']==1)?($strings[27]):($GLOBALS['ROBOKASSA_Title']);

$crumbs = menuManager('four',array("./robokassa.php",$Title));
$result['out'] = $crumbs;
CheckProfile($result,$crumbs,'four');

$isTest = 0; 									// 1 - тестовый режим вкл, 0 - тестовый режим выкл
$mrh_login = $GLOBALS ["ROBOKASSA_Login"];      // ЛОГИН ОТ РОБОКАССЫ
$mrh_pass1 = $GLOBALS ["ROBOKASSA_Password"];   // ПАССВОРД 1

		$otherinfo=explode('||',$result['otherinfo']);
		$ROBOKASSA_ID = $otherinfo[125];
		if ((int)$ROBOKASSA_ID >-1){
			$sql = "SELECT `params` FROM `payment_params` WHERE `id` = '$ROBOKASSA_ID';";
			$mysqlResult = mysql_query($sql,$mysql);
			if (mysql_num_rows($mysqlResult)>0){
				$row = mysql_fetch_array($mysqlResult);
				$Params = GetParams($row[0]);

				$mrh_login = $Params['ROBOKASSA_Login'];
				$mrh_pass1 = $Params['ROBOKASSA_Password'];
				$isTest = $Params['ROBOKASSA_IsTest'];
				
				if (isset($Params['ROBOKASSA_VAT'])){
					if (strlen($Params['ROBOKASSA_VAT'])>0){$ROBOKASSA_VAT = $Params['ROBOKASSA_VAT'];}
				}
				
				if (isset($Params['ROBOKASSA_SNO'])){
					if (strlen($Params['ROBOKASSA_SNO'])>0){$ROBOKASSA_SNO = $Params['ROBOKASSA_SNO'];}
				}
			}
		} else  {
			$sql = "SELECT `params` FROM `payment_params` WHERE `type` = 16";
			$mysqlResult = mysql_query($sql,$mysql);
			if (mysql_num_rows($mysqlResult)>0){
				$row = mysql_fetch_array($mysqlResult);
				$Params = GetParams($row[0]);

				$mrh_login = $Params['ROBOKASSA_Login'];
				$mrh_pass1 = $Params['ROBOKASSA_Password'];
				$isTest = $Params['ROBOKASSA_IsTest'];
				
				if (isset($Params['ROBOKASSA_VAT'])){
					if (strlen($Params['ROBOKASSA_VAT'])>0){$ROBOKASSA_VAT = $Params['ROBOKASSA_VAT'];}
				}
				
				if (isset($Params['ROBOKASSA_SNO'])){
					if (strlen($Params['ROBOKASSA_SNO'])>0){$ROBOKASSA_SNO = $Params['ROBOKASSA_SNO'];}
				}
			}
		}
		

//$result = getuserinfo();

if (isset($_REQUEST['state'])) {
    switch ($_REQUEST['state']){
        case 'success':
			// 301 - Пополнение через ROBOKASSA
			// 254 - Ваш баланс будет пополнен в течении нескольких минут!
            $result['out'] .= OutMessage($strings[301], $strings[254], menuManager('four',["./robokassa.php",$strings[27]]));
            break;
        case 'fail':
			// 301 - Пополнение через ROBOKASSA
			// 302 - Ошибка, платёж был отклонен!
            $result['out'] .= OutMessage($strings[301], $strings[302], menuManager('four',["./robokassa.php",$strings[27]]));
            break;
    }
    echo parse_template($result, './template/default.php');
    exit;
}

	if (isset($_REQUEST['billme']))
	{
		$query = "SELECT user_name, user_pswd, FIO, tarif, ballance, traffic, state, turbo, turboenabled, data1, data2, stopdate, turboisallowed, promisepay, promisepayenabled, curspd, state, otherinfo, tarif_guid, shortguid, tarifends, pinfo, nexttarif, daystopay, paysize, spdlim, isarchived, group_guid, can_reserving, reserving, client_name2, todaytraffic, usrip, reservingnext, `contract`, `paytime` FROM stat WHERE shortguid='".mysql_real_escape_string($_SESSION['shortguid'])."';";

		$result = mysql_query($query,$GLOBALS['mysql']);
		$result = mysql_fetch_assoc($result);
		
		$Shp_shortguid = $result['shortguid'];
		$shp_login = $result['user_name'];
		$inv_desc ="Plata za internet: ".$result['user_name'];
		$allCost=$_REQUEST['sum'];
		//echo $allCost;exit();
	
	//$Receipt = '';$ROBOKASSA_VAT='';
	
	if (!isset($ROBOKASSA_VAT)){$ROBOKASSA_VAT='';}
	if (!isset($ROBOKASSA_SNO)){$ROBOKASSA_SNO='';}
	
	if ((strlen($ROBOKASSA_VAT)>0)&&(strlen($ROBOKASSA_SNO)>0)){
				
		$Receipt = '{"sno":"'.$ROBOKASSA_SNO.'","items":[{"name":"Оплата за Интернет","quantity":1,"sum":'.$allCost.',"payment_method":"full_payment","payment_object":"service","tax":"'.$ROBOKASSA_VAT.'"}]}';
	}else{
		$Receipt = '{}';
	}

	$Receipt_urlencoded=urlencode($Receipt);
	$sig_str="$mrh_login:$allCost::$Receipt_urlencoded:$mrh_pass1:Shp_login=$shp_login:Shp_shortguid=$Shp_shortguid";
	$crc = md5($sig_str);
	if (strlen($Receipt)>0){
		$Receipt = urlencode($Receipt_urlencoded);
	}
	
	//OLD:
	//$URL= 'https://auth.robokassa.ru/Merchant/PaymentForm/FormFLS.js?isTest=' . $isTest . '&MerchantLogin=' . $mrh_login . '&Shp_login=' . $shp_login . '&Shp_shortguid=' . $Shp_shortguid . '&DefaultSum=' . $allCost . '&SignatureValue=' . $crc . '&Culture=ru&Email=' . $email . '&Description=' . $inv_desc . $Receipt . '\\';
	$URL = 'https://auth.robokassa.ru/Merchant/Index.aspx?MerchantLogin='.$mrh_login.'&OutSum='.$allCost.'&invoiceID=&Description='.$inv_desc.'&Shp_login='.$shp_login.'&Shp_shortguid='.$Shp_shortguid.'&SignatureValue='.$crc.'&Receipt=' . $Receipt ;
	//echo $URL.'<br>';
	
	

	
	//echo "Sig = " . $sig_str.'<br>';
	//echo "Sig2 = " . $crc.'<br>';
	//echo "Receipt = " . $Receipt.'<br>';
	header('location: ' . $URL);
	exit();
		
		
	} else {
		
		if (strlen($isTest)==0){$isTest = 0;}

		$query = "SELECT user_name, user_pswd, FIO, tarif, ballance, traffic, state, turbo, turboenabled, data1, data2, stopdate, turboisallowed, promisepay, promisepayenabled, curspd, state, otherinfo, tarif_guid, shortguid, tarifends, pinfo, nexttarif, daystopay, paysize, spdlim, isarchived, group_guid, can_reserving, reserving, client_name2, todaytraffic, usrip, reservingnext, `contract`, `paytime` FROM stat WHERE shortguid='".mysql_real_escape_string($_SESSION['shortguid'])."';";

		$result = mysql_query($query,$GLOBALS['mysql']);
		$result = mysql_fetch_assoc($result);
		
		$OtherInfo = $result['otherinfo'];
		$OtherInfo = explode("||",$OtherInfo);
		$AutoPromisePay = $OtherInfo[10];
		$PromisePayCost = str_replace(',','.',$OtherInfo[29]);
	
		$allCost = $OtherInfo[74];
			
		$pcomm=1;
		$AllComm = (float)$GLOBALS['ROBOKASSA_Commission'];
		if ($GLOBALS['ROBOKASSA_ProviderComission']<>'True'){
			$AllComm += (float)$GLOBALS['ROBOKASSA_Commission2'];
		}
		
		$BalA= explode(' ', $result['ballance']);
		$Bal=floatval(str_replace(',','.',$BalA[0]));
		
		if ($allCost < 0)  {$allCost = 100;}
		if (($allCost == 0) && ($Bal<0)) {
			$allCost = -$Bal;
		}
		
		// 386 - Сумма рассчитана с учётом комиссии
		$comm2=((float)$AllComm-1>0)?$strings[386]." ".$AllComm.'%':'';
		


$email = explode('||', $result['pinfo']);
$email = $email[1];

if (!isset($_POST['pay'])) {

	$v='';
	if ($OtherInfo[77]=='True'){$v='checked';}
	$startat1 = '';
	if ($GLOBALS['ClientCanStartAt1st']=='True'){
		$startat1 = '<div class="m3">
						<input type="checkbox" name="startonfirst" id="startonfirst" '.$v.' onclick="GetHTTP(\'api.php?action=START_ME_AT_1ST&value=\' + this.checked);">
						<label for="startonfirst">'.$strings[214].' - '.$result['paytime'].'</label>
					</div>';
	}
	
	$AllComm = (float)$GLOBALS['ROBOKASSA_Commission'] + (float)$GLOBALS['ROBOKASSA_Commission2'];
	$allCost=GetSummWithComission($allCost,(float)$GLOBALS['ROBOKASSA_Commission'],(float)$GLOBALS['ROBOKASSA_Commission2']);
	
	// 211 - Взымается дополнительная комиссия в размере
		$comm=((float)$AllComm>0)?', '.$strings[211]." ".$AllComm.'%':'';	

		// 213 - Управление платежом
		// 220 - Сумма платежа
		$result['out'] = '
					'.$crumbs.'
					<div class="content">
						<div class="four">
							<i class="fas fa-piggy-bank"></i>
							<div class="h3 m4"></div>
							<div class="m2">'.sprintf($strings[443],'ROBOKASSA').'</div>
							<div class="i m3">'.$strings[220].':</div>
							<form method="POST" target="_blank">
								<div class="m2">
								<input type="text" name="sum" id="sum" value="'.$allCost.'" class="pay"/> '.$GLOBALS['curr'].' '.$comm2.'
								</div>';
								if ($GLOBALS['ClientCanStartAt1st']=='True'){
									$otherinfoA=explode('||', $result['otherinfo']);
									if ($otherinfoA[35]=='0') {
										$v='';
										if ($otherinfoA[77]=='True'){$v='checked';}
										// 214 - Запустить с началом следующего расчётного периода
										$result['out'].='
										<div class="m3">
											<input type="checkbox" name="startonfirst" id="startonfirst" '.$v.'>
											<label for="startonfirst">'.$strings[214].' - '.$result['paytime'].'</label>
										</div>';
									}
								}
								// 215 - Уважаемый абонент! Возможна небольшая комиссия, размер которой зависит от соглашения вашего банка с платёжной системой.
								// 218 - Оплатить
								$result['out'] .= '
									<button type="submit" name="billme" class="m3">'.$strings[218].'</button>
									'.$comm.PrintBonuses(); 
		echo parse_template($result, './template/default.php'); 
		exit;
	}
	

}
?>

			<script type="text/javascript">
				function GetHTTP(url) {
					var request=null;
					request=new XMLHttpRequest();
					request.open(\'GET\', url, false);
					request.send(null);
					return request.responseText;
				}
			</script>

	