<?php

$GLOBALS['faqpage']['page_title'] = 'Frequently asked Questions';
$GLOBALS['faqpage']['contents'] = '
<div class="faqHead">Questions and answers</div>
<div class="faqQuestion">
<br/>
Q2: How can I change the password for access to my account?
</div>
<br style="margin:0px;padding:0px;border:0px;"/>
<span style="margin:0px;padding:0px;border:0px;font-weight:bold;">A2:</span>
 If you want to change the password for the Personal Area: in the Personal Area go to the "Settings" section, in the "Change Password" section enter your old password and enter the new password twice. Then do not forget to click the "Save" button. We recommend that you write down a new password.
<br style="margin:0px;padding:0px;border:0px;"/>
<br style="margin:0px;padding:0px;border:0px;"/>
<div class="faqQuestion">Q3: How and where can I change my tariff plan to another?</div>
<br style="margin:0px;padding:0px;border:0px;"/>
<span style="margin:0px;padding:0px;border:0px;font-weight:bold;">A3:</span>
To change the tariff plan, go to the section "Services and Tariffs", then click on the line "Change tariff plan." Now choose the tariff you are interested in and click on the "Order" button.
<br style="margin:0px;padding:0px;border:0px;"/>
<br style="margin:0px;padding:0px;border:0px;"/>
<div class="faqQuestion">Q4: What is traffic?</div>
<br style="margin:0px;padding:0px;border:0px;"/>
<span style="margin:0px;padding:0px;border:0px;font-weight:bold;">A4:</span>
 Traffic - is the amount of information coming to your computer from the network and sent from it to the network. Every time you browse the Internet, a certain amount of information comes to your computer, measured in bytes.
<br style="margin:0px;padding:0px;border:0px;"/>
<br style="margin:0px;padding:0px;border:0px;"/>
<div class="faqQuestion">Q5:How many bytes in a kilobyte and how many in a megabyte?</div>
<br style="margin:0px;padding:0px;border:0px;"/>
<span style="margin:0px;padding:0px;border:0px;font-weight:bold;">A5:</span>
In general, one kilobyte is 1024 bytes, and in one megabyte it is 1024 kilobytes. 
<br style="margin:0px;padding:0px;border:0px;"/>
<br style="margin:0px;padding:0px;border:0px;"/>
<div class="faqQuestion">Q6: What is "Inbound" and "Outgoing" traffic?</div>
<br style="margin:0px;padding:0px;border:0px;"/>
<span style="margin:0px;padding:0px;border:0px;font-weight:bold;">A6:</span>
 Incoming traffic is the amount of information coming to your computer from the network, and outgoing, respectively, the volume leaving your computer to the network.
<br style="margin:0px;padding:0px;border:0px;"/>
<br style="margin:0px;padding:0px;border:0px;"/>
<div class="faqQuestion">Q7: I have not downloaded a single file from the Internet, and traffic has increased, what should I do?</div>
<br style="margin:0px;padding:0px;border:0px;"/>
<span style="margin:0px;padding:0px;border:0px;font-weight:bold;">A7:</span>
 The fact is that any Internet resource, whether it\'s www, music, video, www-chats, IRC, news server, etc. - is traffic. You are viewing a www-page - it means that some information has come to your computer from the network, you listen to music from the Internet - it means that information is transmitted to the computer from the network.
<br style="margin:0px;padding:0px;border:0px;"/>
<br style="margin:0px;padding:0px;border:0px;"/>
<div class="faqQuestion">Q8: I downloaded the file for 300 kilobytes, and statistics show 308, why?</div>
<br style="margin:0px;padding:0px;border:0px;"/>
<span style="margin:0px;padding:0px;border:0px;font-weight:bold;">A8:</span>
 Data statistics are always a bit more than expected, which is why: all information on the Internet is transmitted in the form of packets, for example, we download a file of 300 kilobytes, this file is divided into pieces, usually 1500 bytes and, in turn, the packet after the packet is transferred to Your computer. To each packet, there is usually 20 bytes of header, it contains information about the sender of the packet and its recipient. That\'s because of these headlines, as a rule, the statistics program data is slightly larger than you expected.
<br style="margin:0px;padding:0px;border:0px;"/>
<br style="margin:0px;padding:0px;border:0px;"/>
<div class="faqQuestion">Q9: Why the speed of the tariff plan does not match the download speed?</div>
<br style="margin:0px;padding:0px;border:0px;"/>
<span style="margin:0px;padding:0px;border:0px;font-weight:bold;">A9:</span>
The download speed is influenced by various factors, for example: <br />
1. Download the channel to the server from which you download the file. <br />
2. Download the server from which you download the file. <br />
3. Speed ​​limits imposed by the server administration. <br />
4. The protocol used to transfer data. <br />
5. Computer hardware, including processor speed, the amount of installed RAM, free space on the hard disk. <br />
6. Licensed software other than Unix. <br />
The real speed of access to the Internet depends not only on the technical features of the service, but also on the actions of the third communication operators, organizations and individuals managing Internet segments that are beyond the responsibility of the Provider.
<br style="margin:0px;padding:0px;border:0px;"/>
<br style="margin:0px;padding:0px;border:0px;"/>

<div class="faqQuestion">Q10: How to disable Automatic Updates in Windows 2000 and XP?</div>
<br style="margin:0px;padding:0px;border:0px;"/>
<span style="margin:0px;padding:0px;border:0px;font-weight:bold;">A10:</span>
 On Windows 2000 and XP, the Automatic Updates service is enabled by default. This feature includes downloading and installing critical Windows updates from a Microsoft server - Windows Update. If you do not disable this service, when you access the Internet, your computer will start downloading large amounts of information, which will lead to winding up traffic received by your computer. To avoid unforeseen expenses, we strongly recommend that you disable this service. To do this, go to Control Panel / Administration / Services / Automatic Updates. In the Startup Type menu, select the Disabled option. This operation must be performed after each reinstallation of Windows.
<br style="margin:0px;padding:0px;border:0px;"/>
<br style="margin:0px;padding:0px;border:0px;"/>
<div class="faqQuestion">Q11: How soon will the Internet start after the account is replenished?</div>
<br style="margin:0px;padding:0px;border:0px;"/>
<span style="margin:0px;padding:0px;border:0px;font-weight:bold;">A11:</span>
After replenishing the account, the Internet will automatically start working within a few minutes.
<br/>
<span style="font-size:0.85em;line-height:1.4em;"> </span>
';

$GLOBALS['prpayintrotext'] = '
								<div>
									The balance is close to zero and there is no time to pay for the Internet? The "Promised Payment" service will help you to prolong the work on the network without the requirement of immediate payment - pay when convenient!
									<p>
									After activating the "Promised Payment" you will have access to the Internet within a few days from the moment the service is activated. During this time, you will need to replenish your personal account in full for the billing period according to your tariff plan + cost of the service and continue working on an ongoing basis.
									<p>
									We also recommend that you order regular activation of "Promised payment" - the service will be automatically activated every time the balance of your personal account becomes negative. We draw your attention to the fact that the actual write-off of money for the provision of services will be made at the moment of its activation.
								</div>';

$GLOBALS['contacts']['page_title'] = 'Contacts';

?>