<style>
.popupinfo
{
	position: absolute;
	bottom: 0;
	right: 0;
    text-align: center;
	background-color: transparent;	
}
.frame
{
	width: 223px;
	height: 235px;
	margin-bottom:7px;
	margin-right:25px;
	background: #FDF1E9;
	border: 2px solid rgb(95,144,189);
	border-radius: 38px;
	opacity: 0.0;
}
.popuphelp
{
	width: 48px;
	height: 48px;
	margin-bottom:7px;
	margin-right:25px;
	background-repeat: no-repeat;
	background-image: url("test/img/help.png");
	cursor: pointer;
	opacity: 1.0;
}



.container {
  position: relative;
  #top: 50%;
  top: 25px;
  #transform: translateY(-50%);
}
.close{
	float: right; 
	margin-right: -15px;
	margin-top: 0px;
	cursor: pointer;
}


input[type=text2] {
  width: 100%;
  box-sizing: border-box;
  border: 1px solid rgb(95,144,189);
  -webkit-transition: 0.5s;
  transition: 0.5s;
  width: 55%;
  margin-top: 7px;
  border-radius: 4px;
  padding: 4px;
  text-align: center; 
}

input[type=text2]:focus {
  border: 1px solid rgb(65,113,156);
  border-radius: 6px;
  width: 75%;
}


.line  {
 border-top: 1px dashed rgb(228, 228, 228);
 height: 18px; 
 margin: 10px;
}
.icons {
	padding: 7px;
	width: 24px;
	height: 24px;
}
</style>

<body>
	<div class="popupinfo frame" id="popupinfo" style="z-index: 999998;">
		<img src="test/img/close.png" class="close" onclick="Hide();">
		<div  class="container" id="conteiner">
			<b>Хотите узнать баланс?</b><br>
			Введите телефон или договор:<br>
			<span id="arrow2" style="opacity:0">➤</span>
			<input type="text2" class="myinput" id="contract" onfocus="TimerID[2]=setInterval(ChangeOpacity,15, 0.05, 1.0, 'arrow', 2);" onfocusout="TimerID[2]=setInterval(ChangeOpacity,15, -0.05, 0.0, 'arrow', 2);">
			<span id="arrow" style="padding-left:0px;opacity:0;cursor:pointer;padding-top:12px;" onclick="GetUserInfo();">➤</span>
			<div id="result"style="padding-top:12px;padding-bottom:5px;height:50px;opacity: 1.0;">
				<font size="6">🪶</font>
			</div>
			<div>
				<div class="line">
					<a href="https://vk.com/mikrobill" target="_blank"><img class="icons" src='test/img/vk.ico'></a><a href="https://t.me/MikroBILL" target="_blank"><img class="icons" src='test/img/tg.ico'></a><a href="tel:1345678915" target="_blank"><img class="icons" src='test/img/call.ico'></a>
				</div>
			</div>
		</div>
	</div>
	
	<div class="popupinfo popuphelp" id="popuphelp" style="z-index: 999999;" onclick="Show();">
		
	</div>
</body>

<script>
	function ReadKey(e) {
	  if (e.keyCode==13){GetUserInfo();}
	}
	
	const input = document.getElementById("contract");
	input.addEventListener("keypress", ReadKey);
	
	function ReadHTTP(url) {
		var request=null;
		request=new XMLHttpRequest();
		request.open('GET', url, false);
		request.send(null);
		return request.responseText;
	}
	
	function ReadHTTP2(url,callback){ 
		var request=null;
		request=new XMLHttpRequest();
		request.open('GET', url);
		request.msCaching = 'disabled';	// for IE
		request.responseType = 'text';
		request.send(null);	
		request.onreadystatechange = function() {
			if (this.readyState == 4) {
				if(this.status == 200) {
					callback(this.response);
				}
			}
		}	
	}
	
	let TimerID=['','','']
	
	function ChangeOpacity(v, dst, El, i){
		let element = document.getElementById(El);
		let Op = Number(element.style.opacity);
		Op += v;
		//console.log(i + ' = ' + Op);
		if ((Op>0)&&(Op<1)){
			element.style.opacity = Op;
		} else {element.style.opacity = dst; clearInterval(TimerID[i]);}
	}
	
	async function GetUserInfo(){
		
		for (let i=0;i<25;i++){
			ChangeOpacity(-0.05, 0, 'result', 2);
			await sleep(5);
		}
		document.getElementById('result').innerHTML=ReadHTTP("test/usr_info_core.php?usr=" + document.getElementById('contract').value);
		for (let i=0;i<25;i++){
			ChangeOpacity(0.05, 1, 'result', 2);
			await sleep(5);
			}
	}
	
	function sleep(ms) {
		return new Promise(resolve => setTimeout(resolve, ms));
	}
	
	function Hide(){
		TimerID[0]=setInterval(ChangeOpacity,15, -0.05, 0, 'popupinfo', 0);
		TimerID[1]=setInterval(ChangeOpacity,15, 0.05, 1, 'popuphelp', 1);
	}
	function Show(){
		TimerID[0]=setInterval(ChangeOpacity,15, 0.05, 1, 'popupinfo', 0);
		TimerID[1]=setInterval(ChangeOpacity,15, -0.05, 0, 'popuphelp', 1);
	}
</script>


